blob: 41d288767eff71217f2caf8334288875e063d178 [file] [log] [blame]
Brian Silvermand1c19fb2016-07-07 00:10:57 -07001#!/bin/bash
2
3# The bazel script calls this instead of the bazel-real binary which is
4# installed next to it. This script downloads a specific version of Bazel and
5# then calls that.
6
7# Alternatively, if the environment variable BAZEL_OVERRIDE is set, that will be
8# run directly (after printing a message). That is intended for testing only.
9
10# This script operates based on the assumption that any directory of the correct
11# name is a fully extracted, valid Bazel installation. It is careful to avoid
12# putting an invalid directory at that name at any point.
13
14set -e
15set -u
16set -o pipefail
17
18if [[ -n "${BAZEL_OVERRIDE+x}" ]]; then
19 tput setaf 1 >&2
20 echo -n "Actually calling " >&2
21 tput setaf 3 >&2
22 echo "${BAZEL_OVERRIDE}" >&2
23 tput sgr0 >&2
24 exec "${BAZEL_OVERRIDE}" "$@"
25fi
26
Austin Schuh4f857292018-02-15 23:42:04 -080027readonly VERSION="201802152317+9b1b63c"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070028
29readonly DOWNLOAD_DIR="$(dirname "${BASH_SOURCE[0]}")/../bazel-downloads"
30# Directory to unpack bazel into. This must change whenever bazel changes.
31readonly VERSION_DIR="${DOWNLOAD_DIR}/${VERSION}-v1"
32readonly VERSION_BAZEL="${VERSION_DIR}/usr/bin/bazel"
33
34# Creating might fail if another invocation is racing us.
35if [[ ! -d "${DOWNLOAD_DIR}" ]]; then
36 mkdir "${DOWNLOAD_DIR}" || true
37fi
38if [[ ! -d "${DOWNLOAD_DIR}" ]]; then
39 echo "Failed to create ${DOWNLOAD_DIR}" >&2
40 exit 1
41fi
42
Austin Schuh9d92e6b2017-10-17 01:19:38 -070043readonly INSTALLER_NAME="bazel_${VERSION}-linux-x86_64.deb"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070044readonly DOWNLOAD_URL="http://frc971.org/Build-Dependencies/${INSTALLER_NAME}"
45
46if [[ ! -d "${VERSION_DIR}" ]]; then
47 echo "Downloading Bazel version ${VERSION} from ${DOWNLOAD_URL}..." >&2
48
49 # A temporary directory which is definitely on the same filesystem as our final
50 # destination, which is important so we can atomically move it.
51 # If this move is non-atomic, then a concurrent Bazel command (like the verifier
52 # uses several of) could use a half-copied Bazel installation.
Philipp Schradere21f1582018-01-18 05:08:55 +000053 mkdir -p "${HOME}/.cache/bazel"
Austin Schuh6b046d42018-01-04 20:20:24 -080054 DOWNLOAD_TEMP_DIR="$(mktemp --directory --tmpdir="${HOME}/.cache/bazel")"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070055 TEMP_DIR="$(mktemp --directory --tmpdir="${DOWNLOAD_DIR}")"
Austin Schuh6b046d42018-01-04 20:20:24 -080056 readonly DOWNLOAD_TEMP_DIR
Brian Silvermand1c19fb2016-07-07 00:10:57 -070057 readonly TEMP_DIR
58
Austin Schuh6b046d42018-01-04 20:20:24 -080059 ( cd "${DOWNLOAD_TEMP_DIR}"
60 # Now, download into the ~/.cache folder
61 if [ ! -e "${HOME}/.cache/bazel/${INSTALLER_NAME}" ];
62 then
63 wget "${DOWNLOAD_URL}" -O "${INSTALLER_NAME}" --no-verbose --show-progress
64 mv "${INSTALLER_NAME}" "${HOME}/.cache/bazel/${INSTALLER_NAME}"
65 fi
66 rm -rf "${DOWNLOAD_TEMP_DIR}"
67 )
68
Brian Silvermand1c19fb2016-07-07 00:10:57 -070069 ( cd "${TEMP_DIR}"
Brian Silvermand1c19fb2016-07-07 00:10:57 -070070 echo "Unpacking Bazel version ${VERSION}..." >&2
Austin Schuh6b046d42018-01-04 20:20:24 -080071 dpkg-deb -x "${HOME}/.cache/bazel/${INSTALLER_NAME}" extracted
Brian Silvermand1c19fb2016-07-07 00:10:57 -070072 )
73
74 touch "${TEMP_DIR}/extracted/usr/bin/bazel.bazelrc"
75
76 # Careful: somebody else might have already done it. If they manage to make
77 # the move between our check and our move, then we'll end up with a random
78 # extracted directory which won't do anybody any harm. If somebody else does
79 # that first, then our move will fail.
80 if [[ ! -d "${VERSION_DIR}" ]]; then
81 mv "${TEMP_DIR}/extracted" "${VERSION_DIR}" || true
82 fi
83 if [[ ! -d "${VERSION_DIR}" ]]; then
84 echo "Failed to create ${VERSION_DIR}" >&2
85 exit 1
86 fi
87 rm -rf "${TEMP_DIR}"
88 echo "Done downloading Bazel version ${VERSION}"
89fi
90
Austin Schuh77cc2c32016-12-28 22:01:38 -080091ENVIRONMENT_VARIABLES=()
92ENVIRONMENT_VARIABLES+=(HOSTNAME="${HOSTNAME}")
93ENVIRONMENT_VARIABLES+=(SHELL="${SHELL}")
94ENVIRONMENT_VARIABLES+=(USER="${USER}")
95ENVIRONMENT_VARIABLES+=(PATH="${PATH}")
Austin Schuh77cc2c32016-12-28 22:01:38 -080096ENVIRONMENT_VARIABLES+=(HOME="${HOME}")
97ENVIRONMENT_VARIABLES+=(LOGNAME="${LOGNAME}")
98ENVIRONMENT_VARIABLES+=(TERM="${TERM}")
99
Brianfcf3ee72017-03-05 13:30:54 -0800100if [[ ! -z "${LANG+x}" ]]; then
101 ENVIRONMENT_VARIABLES+=(LANG="${LANG}")
102fi
103
Austin Schuh77cc2c32016-12-28 22:01:38 -0800104if [[ ! -z "${DISPLAY+x}" ]]; then
105 ENVIRONMENT_VARIABLES+=(DISPLAY="${DISPLAY}")
106fi
107
Brian Silvermand1c19fb2016-07-07 00:10:57 -0700108if [[ -x "${VERSION_BAZEL}-real" ]]; then
109 exec -a "${VERSION_BAZEL}" env -i \
Austin Schuh77cc2c32016-12-28 22:01:38 -0800110 "${ENVIRONMENT_VARIABLES[@]}" \
Brian Silvermand1c19fb2016-07-07 00:10:57 -0700111 "${VERSION_BAZEL}-real" "$@"
112fi
113if [[ -x "${VERSION_BAZEL}" ]]; then
114 exec env -i \
Austin Schuh77cc2c32016-12-28 22:01:38 -0800115 "${ENVIRONMENT_VARIABLES[@]}" \
Brian Silvermand1c19fb2016-07-07 00:10:57 -0700116 "${VERSION_BAZEL}" "$@"
117fi
118
119echo "Can't find the real bazel!" >&2
120exit 1